Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Media
Imports System.Windows.Data

#If Not SILVERLIGHT Then
Imports System.Windows.Controls
#Else
Imports Telerik.Windows.Controls
#End If

Namespace Telerik.Windows.Examples
	Public Class ConditionalStyleSelector
		Inherits StyleSelector
		Public Overloads Overrides Function SelectStyle(item As Object, container As System.Windows.DependencyObject) As System.Windows.Style
			Dim conditionValue As Object = Me.ConditionConverter.Convert(item, Nothing, Nothing, Nothing)
			For Each rule As ConditionalStyleRule In Me.Rules
				If Equals(rule.Value, conditionValue) Then
					Return rule.Style
				End If
			Next


			Return MyBase.SelectStyle(item, container)
		End Function

		Private _Rules As List(Of ConditionalStyleRule)
		Public ReadOnly Property Rules() As List(Of ConditionalStyleRule)
			Get
				If Me._Rules Is Nothing Then
					Me._Rules = New List(Of ConditionalStyleRule)()
				End If

				Return Me._Rules
			End Get
		End Property

		Private _ConditionConverter As IValueConverter
		Public Property ConditionConverter() As IValueConverter
			Get
				Return Me._ConditionConverter
			End Get
			Set
				Me._ConditionConverter = value
			End Set
		End Property
	End Class

	Public Class ConditionalStyleRule
		Private _Value As Object
		Public Property Value() As Object
			Get
				Return Me._Value
			End Get
			Set
				Me._Value = value
			End Set
		End Property

		Private _Style As Style
		Public Property Style() As Style
			Get
				Return Me._Style
			End Get
			Set
				Me._Style = value
			End Set
		End Property
	End Class
End Namespace
